<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: guildhistory.class.php 0001 2012-11-19 19:43:00Z Nefuh $
 * @link       http://www.wowroster.net
 * @package    GuildHistory
 * @subpackage main class
 */

class guildhistory
{
    private $_sort_link = null;
    private $_logtime = null;
    private $_logdate = null;
    private $_fontsize = 1;
    
    /**
     * guildhistory::_construct()
     * 
     * @return null
     */
    function _construct()
    {
        global $roster, $addon;
        $this->utf8_fix = false;
    }
    
    /**
     * guildhistory::get_xml_data()
     * 
     * Function to generate xml feed with all entries for reading by jquery
     * 
     * @return null
     */
    function get_xml_data()
    {
        $logtime = (isset($_GET['logtime']) && !empty($_GET['logtime'])) ? $_GET['logtime'] : null;
        $historie = $this->get_addon_data($logtime);
        $xml_out = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n";
        $xml_out .= '<historie>'."\n";
        foreach ($historie as $key => $keydata)
        {
            $xml_out .= '   <group>'."\n";
            $xml_out .= '       <key>'.$key.'</key>'."\n";
            foreach ($keydata as $data)
            {
                $xml_out .= '       <entrie>'."\n";
                $xml_out .= '           <player1><![CDATA['.$data['player1'].']]></player1>'."\n";
                $xml_out .= '           <player2><![CDATA['.$data['player2'].']]></player2>'."\n";
                $xml_out .= '           <type><![CDATA['.$data['type'].']]></type>'."\n";
                $xml_out .= '           <rank><![CDATA['.$data['rank'].']]></rank>'."\n";
                $xml_out .= '           <date><![CDATA['.$data['date'].']]></date>'."\n";
                $xml_out .= '           <time><![CDATA['.$data['time'].']]></time>'."\n";
                $xml_out .= '           <logtime>'.$data['logtime'].'</logtime>'."\n";
                $xml_out .= '       </entrie>'."\n";
            }
            $xml_out .= '   </group>'."\n";
        }
        $xml_out .= '</historie>';        
        $roster->output['show_header'] = false; 
        $roster->output['show_menu'] = false;  
        $roster->output['show_footer'] = false;
        echo $xml_out;         
        exit;
    }
    
    /**
     * guildhistory::get_dates()
     * 
     * Function to generate xml feed with all available dates for reading by jquery
     * 
     * @return
     */
    function get_dates()
    {
        global $roster, $addon;
        if (!isset($addon['config']['guildhistory_defaultsort']) || empty($addon['config']['guildhistory_defaultsort'])) 
            $addon['config']['guildhistory_defaultsort'] = 'ASC';
      	$order = (isset($_GET['order']) && !empty($_GET['order']) ) ? $_GET['order'] : $addon['config']['guildhistory_defaultsort'];        
    	$query = "SELECT `logtime` FROM `".$roster->db->table('guildhistory', 'guildhistory')."` WHERE `guild_id` = '".$this->get_guild_id()."' ORDER BY `logtime` ".$order.";";
        $res = $roster->db->query($query);
        $xml_out = '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>'."\n";
        $xml_out .= '   <dates>'."\n";
        while ($data = $roster->db->fetch($res))
        {
            $cur_date = date($roster->locale->act['guildhistory_dateformat'], $data['logtime']);
            if ($prev_date != $cur_date)
                $xml_out .= '       <entrie><logtime>'.strtotime($cur_date).'</logtime><date><![CDATA['.$cur_date.']]></date></entrie>'."\n";
            $prev_date = $cur_date;
        }
        $xml_out .= '   </dates>';
        $roster->output['show_header'] = false; 
        $roster->output['show_menu'] = false;  
        $roster->output['show_footer'] = false;
        echo $xml_out;         
        exit;
       
    }
    
    /**
     * guildhistory::get_guild_id()
     * 
     * Function to get the current guild_id from url
     * if this fails, get the id from $roster->data
     * 
     * @return (int) $guild_id
     */
    function get_guild_id()
    {
		$guild_id = null;
        if (isset($_REQUEST['a']) && !empty($_REQUEST['a']))
        {
            $tmp = explode(':', $_REQUEST['a']);
            if ($tmp[0] == 'g') 
                $guild_id = $tmp[1];
            else 
                $guild_id = $roster->data['guild_id'];
        }
        else 
            $guild_id = $roster->data['guild_id'];
		if (!isset($guild_id) || empty($guild_id)) $guild_id = 1; // Set to 1 if all other failed.
		return $guild_id;
    }
    
    /**
     * guildhistory::get_addon_data()
     * 
     * @param integer $logtime (unix timestamp)
     * @param string $group_by (ASC / DESC)
     * @return array $historie (array of all entries found)
     */
    function get_addon_data($logtime = null, $group_by = null)
    {
        global $roster, $addon;
        $historie = array();
        if (!isset($addon['config']['guildhistory_defaultsort']) || empty($addon['config']['guildhistory_defaultsort'])) 
            $addon['config']['guildhistory_defaultsort'] = 'ASC';
      	$order = (isset($_GET['order']) && !empty($_GET['order']) ) ? $_GET['order'] : $addon['config']['guildhistory_defaultsort'];
    	if ($order == 'ASC') 
    	  	$this->_sort_link = '<a class="internal_link" href="'.makelink('guild-guildhistory&amp;order=DESC').'" target="_self">'.$roster->locale->act['sorting_asc'].'</a>';
    	else 
    	  	$this->_sort_link = '<a class="internal_link" href="'.makelink('guild-guildhistory&amp;order=ASC').'" target="_self">'.$roster->locale->act['sorting_desc'].'</a>';			  
   	 if (isset($logtime) && !empty($logtime))
        {
            $logtime_start = $logtime;
            $logtime_end = mktime(23,59,59,date('n', $logtime), date('j', $logtime), date('Y', $logtime));
            $query = "SELECT * FROM `".$roster->db->table('guildhistory', 'guildhistory')."` WHERE `guild_id` = '".$this->get_guild_id()."' AND `logtime` >= '".$logtime_start."' AND `logtime` <= '".$logtime_end."' ".$group_by." ORDER BY `logtime` ".$order.";";
        }
        else
            $query = "SELECT * FROM `".$roster->db->table('guildhistory', 'guildhistory')."` WHERE `guild_id` = '".$this->get_guild_id()."' ".$group_by." ORDER BY `logtime` ".$order.";";
        
        $result = $roster->db->query($query);
        $prev_logdate = null;
    	while ($data = $roster->db->fetch($result)) 
		{
            $this->correct_timeanddate($data);
			if ($prev_logdate != $this->_logdate)
			{
			  	$index = 0;
				$prev_logdate = $this->_logdate;
			}
			else $index++;
            if ($this->utf8_fix == true)
    			$historie[$this->_logdate][$index] = array('player1' => utf8_decode($data['player1']), 
                                                    'player2' => utf8_decode($data['player2']), 
                                                    'type' => $data['type'], 
                                                    'rank' => utf8_decode($data['rank']), 
                                                    'date' => $this->_logdate, 
                                                    'time' => $this->_logtime,
                                                    'logtime' => $data['logtime']);            
            else
    			$historie[$this->_logdate][$index] = array('player1' => $data['player1'], 
                                                    'player2' => $data['player2'], 
                                                    'type' => $data['type'], 
                                                    'rank' => $data['rank'], 
                                                    'date' => $this->_logdate, 
                                                    'time' => $this->_logtime,
                                                    'logtime' => $data['logtime']);
		}            
        return $historie;                
    }
    
    /**
     * guildhistory::check_local_files()
     * 
     * Function to check if there are javascript files foreach language in "./addons/guildhistory/locale"
     * when js file for a language did not exists try to compile and load them. 
     * 
     * @return
     */
    function check_local_files()
    {
        global $roster, $addon;
        $dir = $addon['url'].'locale/';
        if (is_dir($dir)) 
        {
            if ($dh = opendir($dir)) 
            {
                while (($file = readdir($dh)) !== false) 
                {
                    if (filetype($dir.$file) == 'file' && !preg_match('/.js/', $file))
                    {
                        $lang_key = str_replace('.php', null, $file);
                        $js_lang_file = 'guildhistory.lang_'.str_replace('.php', null, $file).'.js';
                        if (!file_exists($dir.$js_lang_file) || filemtime($dir.$file) < filemtime($dir.$js_lang_file))
                        {
                            if (file_exists($dir.$js_lang_file)) @unlink($dir.$js_lang_file);                            
                            $this->compile_js_languages($js_lang_file, $lang_key);
                        }                                                
                    }
                }
                closedir($dh);
            }
        }                
    }
    
    /**
     * guildhistory::compile_js_languages()
     * 
     * Function to compile new language javascript file, for a given language_key
     * 
     * @param string $js_file - Name of javascript file to generate
     * @param string $lang_key - Language key to get translation for
     * @return null
     */
    function compile_js_languages($js_file, $lang_key)
    {
        global $roster, $addon;
        $script = '    var no_data = "'.$roster->locale->wordings[$lang_key]['no_data'].'";'."\n";
        $script .= '    var lang = new Array();'."\n";
        $script .= '    lang["join"] = "'.$roster->locale->wordings[$lang_key]['join'].'";'."\n";
        $script .= '    lang["invite"] = "'.$roster->locale->wordings[$lang_key]['invite'].'";'."\n";
        $script .= '    lang["had"] = "'.$roster->locale->wordings[$lang_key]['had'].'";'."\n";
        $script .= '    lang["promote"] = "'.$roster->locale->wordings[$lang_key]['promote'].'";'."\n";
        $script .= '    lang["demote"] = "'.$roster->locale->wordings[$lang_key]['demote'].'";'."\n";
        $script .= '    lang["to"] = "'.$roster->locale->wordings[$lang_key]['to'].'";'."\n";
        $script .= '    lang["quit"] = "'.$roster->locale->wordings[$lang_key]['quit'].'";'."\n";
        $script .= '    lang["remove"] = "'.$roster->locale->wordings[$lang_key]['remove'].'";'."\n";
        $script .= '    lang["no_data"] = "'.$roster->locale->wordings[$lang_key]['no_data'].'";'."\n";
        $script .= '    lang["login"] = "'.$roster->locale->wordings[$lang_key]['login'].'";'."\n";
        $script .= '    lang["datetime"] = "'.$roster->locale->wordings[$lang_key]['datetime'].'";'."\n";
        $script .= '    lang["action"] = "'.$roster->locale->wordings[$lang_key]['action'].'";'."\n";
        $script .= '    lang["blog_header_text"] = "'.$roster->locale->wordings[$lang_key]['blog_header_text'].'";'."\n";
        $script .= '    lang["blog_header_text_without_accounts"] = "'.$roster->locale->wordings[$lang_key]['blog_header_text_without_accounts'].'";'."\n";
        $script .= '    lang["blog_line_on"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["join"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["remove"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["quit"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["invite"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["demote"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["promote"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["else"] = new Array();'."\n";
        $script .= '    lang["blog_line_on"]["join"][1]= "'.$roster->locale->wordings[$lang_key]['blog_line_on_join_1'].'";'."\n";
        $script .= '    lang["blog_line_on"]["remove"][1] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_remove_1'].'";'."\n";
        $script .= '    lang["blog_line_on"]["quit"][1] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_quit_1'].'";'."\n";
        $script .= '    lang["blog_line_on"]["invite"][1] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_invite_1'].'";'."\n";
        $script .= '    lang["blog_line_on"]["demote"][1] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_demote_1'].'";'."\n";
        $script .= '    lang["blog_line_on"]["promote"][1] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_promote_1'].'";'."\n";
        $script .= '    lang["blog_line_on"]["else"][1] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_else_1'].'";'."\n";        
        $script .= '    lang["blog_line_on"]["join"][2] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_join_2'].'";'."\n";
        $script .= '    lang["blog_line_on"]["remove"][2] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_remove_2'].'";'."\n";
        $script .= '    lang["blog_line_on"]["quit"][2] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_quit_2'].'";'."\n";
        $script .= '    lang["blog_line_on"]["invite"][2] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_invite_2'].'";'."\n";
        $script .= '    lang["blog_line_on"]["demote"][2] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_demote_2'].'";'."\n";
        $script .= '    lang["blog_line_on"]["promote"][2] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_promote_2'].'";'."\n";
        $script .= '    lang["blog_line_on"]["else"][2] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_else_2'].'";'."\n";        
        $script .= '    lang["blog_line_on"]["join"][3] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_join_3'].'";'."\n";
        $script .= '    lang["blog_line_on"]["remove"][3] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_remove_3'].'";'."\n";
        $script .= '    lang["blog_line_on"]["quit"][3] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_quit_3'].'";'."\n";
        $script .= '    lang["blog_line_on"]["invite"][3] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_invite_3'].'";'."\n";
        $script .= '    lang["blog_line_on"]["demote"][3] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_demote_3'].'";'."\n";
        $script .= '    lang["blog_line_on"]["promote"][3] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_promote_3'].'";'."\n";
        $script .= '    lang["blog_line_on"]["else"][3] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_else_3'].'";'."\n";        
        $script .= '    lang["blog_line_on"]["join"][4] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_join_4'].'";'."\n";
        $script .= '    lang["blog_line_on"]["remove"][4] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_remove_4'].'";'."\n";
        $script .= '    lang["blog_line_on"]["quit"][4] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_quit_4'].'";'."\n";
        $script .= '    lang["blog_line_on"]["invite"][4] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_invite_4'].'";'."\n";
        $script .= '    lang["blog_line_on"]["demote"][4] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_demote_4'].'";'."\n";
        $script .= '    lang["blog_line_on"]["promote"][4] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_promote_4'].'";'."\n";
        $script .= '    lang["blog_line_on"]["else"][4] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_else_4'].'";'."\n";        
        $script .= '    lang["blog_line_on"]["join"][5] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_join_5'].'";'."\n";
        $script .= '    lang["blog_line_on"]["remove"][5] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_remove_5'].'";'."\n";
        $script .= '    lang["blog_line_on"]["quit"][5] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_quit_5'].'";'."\n";
        $script .= '    lang["blog_line_on"]["invite"][5] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_invite_5'].'";'."\n";
        $script .= '    lang["blog_line_on"]["demote"][5] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_demote_5'].'";'."\n";
        $script .= '    lang["blog_line_on"]["promote"][5] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_promote_5'].'";'."\n";
        $script .= '    lang["blog_line_on"]["else"][5] = "'.$roster->locale->wordings[$lang_key]['blog_line_on_else_5'].'";'."\n";
        $script .= '    lang["blog_text_on"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["join"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["remove"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["quit"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["invite"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["demote"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["promote"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["else"] = new Array();'."\n";
        $script .= '    lang["blog_text_on"]["join"][1] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_join_1'].'";'."\n";
        $script .= '    lang["blog_text_on"]["remove"][1] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_remove_1'].'";'."\n";
        $script .= '    lang["blog_text_on"]["quit"][1] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_quit_1'].'";'."\n";
        $script .= '    lang["blog_text_on"]["invite"][1] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_invite_1'].'";'."\n";
        $script .= '    lang["blog_text_on"]["demote"][1] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_demote_1'].'";'."\n";
        $script .= '    lang["blog_text_on"]["promote"][1] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_promote_1'].'";'."\n";
        $script .= '    lang["blog_text_on"]["else"][1] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_else_1'].'";'."\n";        
        $script .= '    lang["blog_text_on"]["join"][2] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_join_2'].'";'."\n";
        $script .= '    lang["blog_text_on"]["remove"][2] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_remove_2'].'";'."\n";
        $script .= '    lang["blog_text_on"]["quit"][2] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_quit_2'].'";'."\n";
        $script .= '    lang["blog_text_on"]["invite"][2] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_invite_2'].'";'."\n";
        $script .= '    lang["blog_text_on"]["demote"][2] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_demote_2'].'";'."\n";
        $script .= '    lang["blog_text_on"]["promote"][2] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_promote_2'].'";'."\n";
        $script .= '    lang["blog_text_on"]["else"][2] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_else_2'].'";'."\n";        
        $script .= '    lang["blog_text_on"]["join"][3] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_join_3'].'";'."\n";
        $script .= '    lang["blog_text_on"]["remove"][3] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_remove_3'].'";'."\n";
        $script .= '    lang["blog_text_on"]["quit"][3] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_quit_3'].'";'."\n";
        $script .= '    lang["blog_text_on"]["invite"][3] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_invite_3'].'";'."\n";
        $script .= '    lang["blog_text_on"]["demote"][3] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_demote_3'].'";'."\n";
        $script .= '    lang["blog_text_on"]["promote"][3] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_promote_3'].'";'."\n";
        $script .= '    lang["blog_text_on"]["else"][3] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_else_3'].'";'."\n";        
        $script .= '    lang["blog_text_on"]["join"][4] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_join_4'].'";'."\n";
        $script .= '    lang["blog_text_on"]["remove"][4] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_remove_4'].'";'."\n";
        $script .= '    lang["blog_text_on"]["quit"][4] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_quit_4'].'";'."\n";
        $script .= '    lang["blog_text_on"]["invite"][4] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_invite_4'].'";'."\n";
        $script .= '    lang["blog_text_on"]["demote"][4] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_demote_4'].'";'."\n";
        $script .= '    lang["blog_text_on"]["promote"][4] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_promote_4'].'";'."\n";
        $script .= '    lang["blog_text_on"]["else"][4] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_else_4'].'";'."\n";       
        $script .= '    lang["blog_text_on"]["join"][5] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_join_5'].'";'."\n";
        $script .= '    lang["blog_text_on"]["remove"][5] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_remove_5'].'";'."\n";
        $script .= '    lang["blog_text_on"]["quit"][5] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_quit_5'].'";'."\n";
        $script .= '    lang["blog_text_on"]["invite"][5] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_invite_5'].'";'."\n";
        $script .= '    lang["blog_text_on"]["demote"][5] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_demote_5'].'";'."\n";
        $script .= '    lang["blog_text_on"]["promote"][5] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_promote_5'].'";'."\n";
        $script .= '    lang["blog_text_on"]["else"][5] = "'.$roster->locale->wordings[$lang_key]['blog_text_on_else_5'].'";'."\n";
        $filename = $addon['url'].'locale/'.$js_file;
        if ($handle = fopen($filename, "a"))
        {
            fwrite($handle, $script); 
            fclose($handle);
            $locale_file_to_load = $addon['url'].'locale/guildhistory.lang_'.$roster->config['locale'].'.js';
            if ($filename == $locale_file_to_load)
                roster_add_js($filename);
        }
    }
    
    /**
     * guildhistory::add_script()
     * 
     * Function to add an additional javascript to the addon
     * the script is needed to let javascript some php variables know.
     * This function also checks if theres a javascript language file available
     * and if not its throws out a generated script with javascript language variables.
     * (Failback so that the addon should work, even without compiled javascript language files).
     * 
     * @return
     */
    function add_script()
    {
        global $roster, $addon;
        $this->check_local_files();
        $script = null;
        if (!isset($addon['config']['guildhistory_defaultsort']) || empty($addon['config']['guildhistory_defaultsort'])) 
            $addon['config']['guildhistory_defaultsort'] = 'ASC';
      	$order = (isset($_GET['order']) && !empty($_GET['order']) ) ? $_GET['order'] : $addon['config']['guildhistory_defaultsort'];        
        $script = '<script type="text/javascript">'."\n";
        $script .= '    var order = "'.$order.'";'."\n";
        $script .= '    var guild_id = '.$this->get_guild_id().';'."\n";
        $script .= '    var textformat = '.$addon['config']['guildhistory_textformat'].';'."\n";
        $script .= '    var num_members = '.$roster->data['guild_num_members'].';'."\n";
        $script .= '    var guildname = "'.$roster->data['guild_name'].'";'."\n";
        $script .= '    var num_accounts = '.$roster->data['guild_num_accounts'].';'."\n";
        // Failback if compiled language javascript file did not exists
        if (!file_exists($addon['url'].'locale/guildhistory.lang_'.$roster->config['locale'].'.js')) 
        {
            $script .= '    var no_data = "'.$roster->locale->act['no_data'].'";'."\n";
            $script .= '    var lang = new Array();'."\n";
            $script .= '    lang["join"] = "'.$roster->locale->act['join'].'";'."\n";
            $script .= '    lang["invite"] = "'.$roster->locale->act['invite'].'";'."\n";
            $script .= '    lang["had"] = "'.$roster->locale->act['had'].'";'."\n";
            $script .= '    lang["promote"] = "'.$roster->locale->act['promote'].'";'."\n";
            $script .= '    lang["demote"] = "'.$roster->locale->act['demote'].'";'."\n";
            $script .= '    lang["to"] = "'.$roster->locale->act['to'].'";'."\n";
            $script .= '    lang["quit"] = "'.$roster->locale->act['quit'].'";'."\n";
            $script .= '    lang["remove"] = "'.$roster->locale->act['remove'].'";'."\n";
            $script .= '    lang["no_data"] = "'.$roster->locale->act['no_data'].'";'."\n";
            $script .= '    lang["login"] = "'.$roster->locale->act['login'].'";'."\n";
            $script .= '    lang["datetime"] = "'.$roster->locale->act['datetime'].'";'."\n";
            $script .= '    lang["action"] = "'.$roster->locale->act['action'].'";'."\n";
            $script .= '    lang["blog_header_text"] = "'.$roster->locale->act['blog_header_text'].'";'."\n";
            $script .= '    lang["blog_header_text_without_accounts"] = "'.$roster->locale->act['blog_header_text_without_accounts'].'";'."\n";
            $script .= '    lang["blog_line_on"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["join"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["remove"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["quit"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["invite"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["demote"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["promote"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["else"] = new Array();'."\n";
            $script .= '    lang["blog_line_on"]["join"][1]= "'.$roster->locale->act['blog_line_on_join_1'].'";'."\n";
            $script .= '    lang["blog_line_on"]["remove"][1] = "'.$roster->locale->act['blog_line_on_remove_1'].'";'."\n";
            $script .= '    lang["blog_line_on"]["quit"][1] = "'.$roster->locale->act['blog_line_on_quit_1'].'";'."\n";
            $script .= '    lang["blog_line_on"]["invite"][1] = "'.$roster->locale->act['blog_line_on_invite_1'].'";'."\n";
            $script .= '    lang["blog_line_on"]["demote"][1] = "'.$roster->locale->act['blog_line_on_demote_1'].'";'."\n";
            $script .= '    lang["blog_line_on"]["promote"][1] = "'.$roster->locale->act['blog_line_on_promote_1'].'";'."\n";
            $script .= '    lang["blog_line_on"]["else"][1] = "'.$roster->locale->act['blog_line_on_else_1'].'";'."\n";        
            $script .= '    lang["blog_line_on"]["join"][2] = "'.$roster->locale->act['blog_line_on_join_2'].'";'."\n";
            $script .= '    lang["blog_line_on"]["remove"][2] = "'.$roster->locale->act['blog_line_on_remove_2'].'";'."\n";
            $script .= '    lang["blog_line_on"]["quit"][2] = "'.$roster->locale->act['blog_line_on_quit_2'].'";'."\n";
            $script .= '    lang["blog_line_on"]["invite"][2] = "'.$roster->locale->act['blog_line_on_invite_2'].'";'."\n";
            $script .= '    lang["blog_line_on"]["demote"][2] = "'.$roster->locale->act['blog_line_on_demote_2'].'";'."\n";
            $script .= '    lang["blog_line_on"]["promote"][2] = "'.$roster->locale->act['blog_line_on_promote_2'].'";'."\n";
            $script .= '    lang["blog_line_on"]["else"][2] = "'.$roster->locale->act['blog_line_on_else_2'].'";'."\n";        
            $script .= '    lang["blog_line_on"]["join"][3] = "'.$roster->locale->act['blog_line_on_join_3'].'";'."\n";
            $script .= '    lang["blog_line_on"]["remove"][3] = "'.$roster->locale->act['blog_line_on_remove_3'].'";'."\n";
            $script .= '    lang["blog_line_on"]["quit"][3] = "'.$roster->locale->act['blog_line_on_quit_3'].'";'."\n";
            $script .= '    lang["blog_line_on"]["invite"][3] = "'.$roster->locale->act['blog_line_on_invite_3'].'";'."\n";
            $script .= '    lang["blog_line_on"]["demote"][3] = "'.$roster->locale->act['blog_line_on_demote_3'].'";'."\n";
            $script .= '    lang["blog_line_on"]["promote"][3] = "'.$roster->locale->act['blog_line_on_promote_3'].'";'."\n";
            $script .= '    lang["blog_line_on"]["else"][3] = "'.$roster->locale->act['blog_line_on_else_3'].'";'."\n";        
            $script .= '    lang["blog_line_on"]["join"][4] = "'.$roster->locale->act['blog_line_on_join_4'].'";'."\n";
            $script .= '    lang["blog_line_on"]["remove"][4] = "'.$roster->locale->act['blog_line_on_remove_4'].'";'."\n";
            $script .= '    lang["blog_line_on"]["quit"][4] = "'.$roster->locale->act['blog_line_on_quit_4'].'";'."\n";
            $script .= '    lang["blog_line_on"]["invite"][4] = "'.$roster->locale->act['blog_line_on_invite_4'].'";'."\n";
            $script .= '    lang["blog_line_on"]["demote"][4] = "'.$roster->locale->act['blog_line_on_demote_4'].'";'."\n";
            $script .= '    lang["blog_line_on"]["promote"][4] = "'.$roster->locale->act['blog_line_on_promote_4'].'";'."\n";
            $script .= '    lang["blog_line_on"]["else"][4] = "'.$roster->locale->act['blog_line_on_else_4'].'";'."\n";        
            $script .= '    lang["blog_line_on"]["join"][5] = "'.$roster->locale->act['blog_line_on_join_5'].'";'."\n";
            $script .= '    lang["blog_line_on"]["remove"][5] = "'.$roster->locale->act['blog_line_on_remove_5'].'";'."\n";
            $script .= '    lang["blog_line_on"]["quit"][5] = "'.$roster->locale->act['blog_line_on_quit_5'].'";'."\n";
            $script .= '    lang["blog_line_on"]["invite"][5] = "'.$roster->locale->act['blog_line_on_invite_5'].'";'."\n";
            $script .= '    lang["blog_line_on"]["demote"][5] = "'.$roster->locale->act['blog_line_on_demote_5'].'";'."\n";
            $script .= '    lang["blog_line_on"]["promote"][5] = "'.$roster->locale->act['blog_line_on_promote_5'].'";'."\n";
            $script .= '    lang["blog_line_on"]["else"][5] = "'.$roster->locale->act['blog_line_on_else_5'].'";'."\n";
            $script .= '    lang["blog_text_on"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["join"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["remove"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["quit"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["invite"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["demote"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["promote"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["else"] = new Array();'."\n";
            $script .= '    lang["blog_text_on"]["join"][1] = "'.$roster->locale->act['blog_text_on_join_1'].'";'."\n";
            $script .= '    lang["blog_text_on"]["remove"][1] = "'.$roster->locale->act['blog_text_on_remove_1'].'";'."\n";
            $script .= '    lang["blog_text_on"]["quit"][1] = "'.$roster->locale->act['blog_text_on_quit_1'].'";'."\n";
            $script .= '    lang["blog_text_on"]["invite"][1] = "'.$roster->locale->act['blog_text_on_invite_1'].'";'."\n";
            $script .= '    lang["blog_text_on"]["demote"][1] = "'.$roster->locale->act['blog_text_on_demote_1'].'";'."\n";
            $script .= '    lang["blog_text_on"]["promote"][1] = "'.$roster->locale->act['blog_text_on_promote_1'].'";'."\n";
            $script .= '    lang["blog_text_on"]["else"][1] = "'.$roster->locale->act['blog_text_on_else_1'].'";'."\n";        
            $script .= '    lang["blog_text_on"]["join"][2] = "'.$roster->locale->act['blog_text_on_join_2'].'";'."\n";
            $script .= '    lang["blog_text_on"]["remove"][2] = "'.$roster->locale->act['blog_text_on_remove_2'].'";'."\n";
            $script .= '    lang["blog_text_on"]["quit"][2] = "'.$roster->locale->act['blog_text_on_quit_2'].'";'."\n";
            $script .= '    lang["blog_text_on"]["invite"][2] = "'.$roster->locale->act['blog_text_on_invite_2'].'";'."\n";
            $script .= '    lang["blog_text_on"]["demote"][2] = "'.$roster->locale->act['blog_text_on_demote_2'].'";'."\n";
            $script .= '    lang["blog_text_on"]["promote"][2] = "'.$roster->locale->act['blog_text_on_promote_2'].'";'."\n";
            $script .= '    lang["blog_text_on"]["else"][2] = "'.$roster->locale->act['blog_text_on_else_2'].'";'."\n";        
            $script .= '    lang["blog_text_on"]["join"][3] = "'.$roster->locale->act['blog_text_on_join_3'].'";'."\n";
            $script .= '    lang["blog_text_on"]["remove"][3] = "'.$roster->locale->act['blog_text_on_remove_3'].'";'."\n";
            $script .= '    lang["blog_text_on"]["quit"][3] = "'.$roster->locale->act['blog_text_on_quit_3'].'";'."\n";
            $script .= '    lang["blog_text_on"]["invite"][3] = "'.$roster->locale->act['blog_text_on_invite_3'].'";'."\n";
            $script .= '    lang["blog_text_on"]["demote"][3] = "'.$roster->locale->act['blog_text_on_demote_3'].'";'."\n";
            $script .= '    lang["blog_text_on"]["promote"][3] = "'.$roster->locale->act['blog_text_on_promote_3'].'";'."\n";
            $script .= '    lang["blog_text_on"]["else"][3] = "'.$roster->locale->act['blog_text_on_else_3'].'";'."\n";        
            $script .= '    lang["blog_text_on"]["join"][4] = "'.$roster->locale->act['blog_text_on_join_4'].'";'."\n";
            $script .= '    lang["blog_text_on"]["remove"][4] = "'.$roster->locale->act['blog_text_on_remove_4'].'";'."\n";
            $script .= '    lang["blog_text_on"]["quit"][4] = "'.$roster->locale->act['blog_text_on_quit_4'].'";'."\n";
            $script .= '    lang["blog_text_on"]["invite"][4] = "'.$roster->locale->act['blog_text_on_invite_4'].'";'."\n";
            $script .= '    lang["blog_text_on"]["demote"][4] = "'.$roster->locale->act['blog_text_on_demote_4'].'";'."\n";
            $script .= '    lang["blog_text_on"]["promote"][4] = "'.$roster->locale->act['blog_text_on_promote_4'].'";'."\n";
            $script .= '    lang["blog_text_on"]["else"][4] = "'.$roster->locale->act['blog_text_on_else_4'].'";'."\n";       
            $script .= '    lang["blog_text_on"]["join"][5] = "'.$roster->locale->act['blog_text_on_join_5'].'";'."\n";
            $script .= '    lang["blog_text_on"]["remove"][5] = "'.$roster->locale->act['blog_text_on_remove_5'].'";'."\n";
            $script .= '    lang["blog_text_on"]["quit"][5] = "'.$roster->locale->act['blog_text_on_quit_5'].'";'."\n";
            $script .= '    lang["blog_text_on"]["invite"][5] = "'.$roster->locale->act['blog_text_on_invite_5'].'";'."\n";
            $script .= '    lang["blog_text_on"]["demote"][5] = "'.$roster->locale->act['blog_text_on_demote_5'].'";'."\n";
            $script .= '    lang["blog_text_on"]["promote"][5] = "'.$roster->locale->act['blog_text_on_promote_5'].'";'."\n";
            $script .= '    lang["blog_text_on"]["else"][5] = "'.$roster->locale->act['blog_text_on_else_5'].'";'."\n";
        }
        $script .= '</script>'."\n";   
        return $script;
    }
    
    /**
     * guildhistory::gen_addon_header()
     * 
     * @param bool $first_block - Set to true if global block header should displayed first
     * @param integer $date - Unix timestamp
     * @param mixed $id - ID of the block content div, for toggling by jquery (show/hide)
     * @return mixed $content - Build block header
     */
    function gen_addon_header($first_block = true, $date = null, $id = null)
    {
        global $roster, $addon;
        $content = null;
        $toggler = null;
        $this->_fontsize = $addon['config']['guildhistory_fontsize'];
        $content .= '<div class="border_frame" style="font-size:'.$this->_fontsize.'em;">'."\n";    	
		if ($addon['config']['guildhistory_textformat'] == 0)
		{
            if ($first_block == true)
                $content .= '<div class="membersrow1" style="text-align:center; padding:5px;">'.$this->_sort_link.'</div>'."\n";
            if (isset($id) && !empty($id))
                $toggler = '<span id="btn_'.$id.'" onclick="gh_toggle('.$id.');" class="ui-icon ui-icon-circle-plus"><span>';
            $content .= '<div class="membersHeader">'."\n";            
            $content .= '   <div style="width:30%; float:left; text-align:left; font-size:'.$this->_fontsize.'em;">'.( (!isset($date) || empty($date)) ? $roster->locale->act['datetime']: $date).'</div>'."\n";
			$content .= '	<div style="width:70%; float:right; text-align:right; font-size:'.$this->_fontsize.'em;">'.( (!isset($date) || empty($date)) ? $roster->locale->act['action']: $toggler).'</div>'."\n";
            $content .= '   <br clear="all" />'."\n";
			$content .= '</div>'."\n";        
        }
        else
        {
            if ($first_block == true)
                $content .= '<h2 style="text-align:center;">'.str_replace('%3', $roster->data['guild_num_accounts'], 
                            str_replace('%2', $roster->data['guild_num_members'], 
                            str_replace('%1', $roster->data['guild_name'], 
                           (($roster->data['guild_num_accounts'] > 0) ? $roster->locale->act['blog_header_text'] : $roster->locale->act['blog_header_text_without_accounts'])))).'</h2></div><br /><div class="border_frame">';
            if (isset($id) && !empty($id))
                $toggler = '<span id="btn_'.$id.'" onclick="gh_toggle('.$id.');" class="ui-icon ui-icon-circle-plus"><span>';
            $content .= '<div class="membersHeader" style="font-size:'.$this->_fontsize.'em; text-align:left;"><div style="width:80%; float:left;">'."\n";
            $content .= $date;
			$content .= '</div><div style="width:20%; float:right; text-align:right;">'.$toggler.'</div><br clear="both" /></div>'."\n";        
        }
        $content .= '</div>'."\n";
        return $content;
    }
    
    /**
     * guildhistory::correct_timeanddate()
     * 
     * Function to correct date and time format, to a format thats set in the locale file.
     * 
     * @param array $data
     * @return null
     */
    function correct_timeanddate($data)
    {
        global $addon, $roster;
	 	$this->_logtime = date($roster->locale->act['guildhistory_timeformat'], $data['logtime']);
 		$this->_logdate = date($roster->locale->act['guildhistory_dateformat'], $data['logtime']);
    }
    
    /**
     * guildhistory::show_history_ajax()
     * 
     * Function to generate main addon output, if ajax is enabled.
     * This isnt much, because the main work, is done by jquery. 
     * 
     * @return mixed $content - Addon output
     */
    function show_history_ajax()
    {
        global $roster, $addon;
        $content = null;
        $content .= $this->add_script();
        $content .= '<div class="day_selector border_frame" style="padding:5px; font-weight:bold;">'.$roster->locale->act['select_day_to_show'].' <span class="date_selector"></span></div><br />'."\n";
        $content .= '<div class="border_frame">'."\n";
        $content .= '   <div id="loading"></div>'."\n";
        $content .= '   <div id="header" style="padding:5px; text-align:center;"></div>'."\n";
        $content .= '   <div id="content" style="padding:0px;">'."\n";
        $content .= '   </div>'."\n";
        $content .= '</div>'."\n";
        return $content;
    }
    
    /**
     * guildhistory::show_history_no_ajax()
     * 
     * Function to generate main addon output, when in addon config ajax is set to off.
     * So here all the work is done by php and its not so flexible like the ajax version above.
     * 
     * @return mixed $content - Addon output
     */
    function show_history_no_ajax()
    {
        global $addon, $roster;
        $content = null;
        $content .= $this->add_script();
        $membersrow = 1;
        $historie = array();
        $historie = $this->get_addon_data();
        if (count($historie) > 0) 
    	{
    		if ($addon['config']['guildhistory_textformat'] == 0)
    		{
                $first_block = true; 	       
    		    foreach ($historie as $key => $data) 
    	    	{
                    $content .= $this->gen_addon_header($first_block, $key, strtotime($key));
                    $content .= '   <div id="'.strtotime($key).'"  class="border_frame" style="display:none; font-size:'.$this->_fontsize.'em; border-top:0px;">'."\n";
   	                foreach ($data as $index => $entrie)
                    {
        				if (!empty($entrie['type']))
        				{
        				    $content .= '   <div style="padding:5px;" id="'.$key.'" class="'.(($membersrow == 1) ? "membersRowColor1" : "membersRowColor2").'">'."\n";
        					$content .= '     <div style="width:30%; float:left;">'.$key.'</div>'."\n";
                            $content .= '     <div style="width:70%; float:right;">';
        					if ($entrie['type'] == 'join') 
        					  	$content .= $entrie['player1'].'&nbsp;'.$roster->locale->act[$entrie['type']];
        					elseif ($entrie['type'] == 'remove')
        					  	$content .= $entrie['player1'].'&nbsp;'.$roster->locale->act[$entrie['type']].'&nbsp;'.$entrie['player2'];			  
        					elseif ($entrie['type'] == 'invite') 
        						$content .= $entrie['player1'].'&nbsp;'.$roster->locale->act['had'].'&nbsp;'.$entrie['player2'].'&nbsp;'.
                                            $roster->locale->act[$entrie['type']];  
        					elseif ($entrie['type'] == 'quit')
        						$content .= $entrie['player1'].'&nbsp;'.$roster->locale->act[$entrie['type']];
        					else 
        						$content .= $entrie['player1'].'&nbsp;'.$roster->locale->act[$entrie['type']].
        									'&nbsp;'.$entrie['player2'].'&nbsp;'.$roster->locale->act['to'].
        									'&nbsp;'.$entrie['rank'];
        					$content .= '     </div><br clear="all" /></div>'."\n";
                            if ($membersrow == 1) $membersrow++;
                            else $membersrow = 1;
        				}
                    }
                    $first_block = false;
    			    $content .= '   </div><br />'."\n";
    			}
    		}
    		else 
            {                    
                $first_block = true; 	       
			    foreach ($historie as $key => $data) 
	    		{
                    $content .= $this->gen_addon_header($first_block, $key, strtotime($key));
                    $content .= '   <div id="'.strtotime($key).'"  class="border_frame" style="display:none; font-size:'.$this->_fontsize.'em; border-top:0px;">'."\n";
                    foreach ($data as $entrie)
                    {
    	    	  		$rnd = rand(1,5);
                        switch($entrie['type'])
                        {
                            default:
                                $selected_local = $roster->locale->act['blog_line_on_else_'.$rnd];
                                break;
                            case 'join':
    						  	$selected_local = $roster->locale->act['blog_line_on_join_'.$rnd];
                                break;
                            case 'remove':
    					  		$selected_local = $roster->locale->act['blog_line_on_remove_'.$rnd];
                                break;
                            case 'quit':
    						  	$selected_local = $roster->locale->act['blog_line_on_quit_'.$rnd];
                                break;
                            case 'invite':
    						  	$selected_local = $roster->locale->act['blog_line_on_invite_'.$rnd];
                                break;
                            case 'demote':
    						  	$selected_local = $roster->locale->act['blog_line_on_demote_'.$rnd];
                                break;
                            case 'promote':
    						  	$selected_local = $roster->locale->act['blog_line_on_promote_'.$rnd];
                                break;
                        }                            
                        $this->correct_timeanddate($entrie);                            
    					$content .= '<div style="padding:5px;" class="'.( ($membersrow == 1) ? "membersRowColor1" : "membersRowColor2").'">'.str_replace('%5', $entrie['rank'], str_replace('%4', $this->_logtime, str_replace('%3', $this->_logdate, 
                                    str_replace('%2', $entrie['player2'], str_replace('%1', $entrie['player1'],	$selected_local))))).'</div>';
                        $prev_logdate = $key;
                        if ($membersrow == 1) $membersrow++;
                        else $membersrow = 1;
                    }
                    $first_block = false;
				    $content .= '   </div><br />'."\n";
                }
    		}
    	}
    	else 
    	{
    	  		$content .= '<div class="border_frame"><div class="membersHeader" style="padding:5px; font-size:1.5em; text-align:center;">'."\n";
                $content .= '   '.$roster->locale->act['guildhistory']."\n";
                $content .= '</div>'."\n";
                $content .= '<div class="membersrow1" style="padding:5px; font-size:1.2em; text-align:center;">'."\n";
    		  	$content .= '  '.$roster->locale->act['no_data']."\n";
                $content .= '</div></div>'."\n";
    	}
        return $content;   
    }
}