<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: install.def.php 1705 2012-11-19 19:41:00Z Nefuh $
 * @link       http://www.wowroster.net
 * @package    GuildHistory
 * @subpackage Installer
*/

if (!defined('IN_ROSTER')) exit('Detected invalid access to this file!'); 

/**
 * Installer GuildHistory
 *
 * @package    GuildHistory
 * @subpackage Installer
 */
class guildhistoryInstall
{
	var $active = true;
	var $icon = 'inv_misc_book_06';
	var $version = '2.3.1';	// ALWAYS NOTE BELOW IN upgrade() WHY THE VERSION NUMBER HAS CHANGED, EVEN WHEN ONLY UPDATING KEY DEFINES
	var $wrnet_id = '124';
	var $fullname = 'guildhistory';
	var $description = 'guildhistory_desc';
	var $credits = array(
		array(	"name"=>	"Joerg Hufen, 2008 - 2012",
				"info"=>	"Displays the GuildHistory tracking by WoWRoster-Profiler")
	);
	/**
	 * Install Function
	 *
	 * @return bool
	 */
	function install()
	{
		global $installer;

		// Master and menu entries
		$installer->add_config("'1','startpage','guildhistory_conf','display','master'");
		$installer->add_config("'110','guildhistory_conf',NULL,'blockframe','menu'");
		$installer->add_config("'1010','guildhistory_access','11:1','access','guildhistory_conf'");
		$installer->add_config("'1020','guildhistory_textformat', '0', 'radio{extended^1|simple^0', 'guildhistory_conf'");
        $installer->add_config("'1030','guildhistory_mouse_over', '1', 'radio{on^1|off^0', 'guildhistory_conf'");
        $installer->add_config("'1040','guildhistory_ajax', '1', 'radio{on^1|off^0', 'guildhistory_conf'");            
        $installer->add_config("'1050', 'guildhistory_fontsize', '1', 'select{0.5em^0.5|0.8em^0.8|1em^1|1.5em^1.5|2em^2|2.5em,2.5|3em,3', 'guildhistory_conf'");            
        $installer->add_config("'1060', 'guildhistory_defaultsort', 'ASC', 'select{Ascending^ASC|Descending^DESC', 'guildhistory_conf'");            
        $installer->add_config("'1070', 'guildhistory_autopurge', '0', 'select{Never^0|1^1|2^2|3^3|4^4|5^5|6^6|12^12|24^24|36^36|48^48', 'guildhistory_conf'");            
		$installer->add_menu_button('guildhistorybutton','guild');
 		$installer->create_table($installer->table('guildhistory'),"
  					`guild_id` int(11) NOT NULL,
					`id` tinyint(3) NOT NULL,
  					`player1` varchar(255) NOT NULL,
  					`type` varchar(100) NOT NULL,
  					`player2` varchar(255) NOT NULL,
  					`time` int(20) default NULL,
  					`logtime` int(20) default NULL,
  					`rank` varchar(100) NOT NULL,
  					KEY `player1` (`player1`),
  					KEY `guild_id` (`guild_id`)");
		return true;
	}
	/**
	 * Upgrade Function
	 *
	 * @param string $oldversion
	 * @return bool
	 */
	function upgrade($oldversion)
	{
		global $installer;
		if( version_compare('1.9.9.1702', $oldversion,'>') == true )
		{
			$installer->add_config("'1020','guildhistory_format', '0', 'radio{long^1|short^0', 'guildhistory_conf'");
			$installer->add_config("'1030','guildhistory_line_format', '0', 'radio{block^1|single^0', 'guildhistory_conf'");
		}		
		if( version_compare('1.9.9.1703', $oldversion,'>') == true )
		{
			$installer->remove_all_config();
			$installer->add_config("'1','startpage','guildhistory_conf','display','master'");
			$installer->add_config("'110','guildhistory_conf',NULL,'blockframe','menu'");
			#$installer->add_config("'200','guildhistory_cats','rostercp-addon-guildhistory-categories','makelink','menu'");
			$installer->add_config("'1010','guildhistory_access','11:1','access','guildhistory_conf'");
			$installer->add_config("'1020','guildhistory_format', '0', 'radio{long^1|short^0', 'guildhistory_conf'");
			$installer->add_config("'1030','guildhistory_line_format', '0', 'radio{block^1|single^0', 'guildhistory_conf'");
		}
		if( version_compare('1.9.9.1705', $oldversion,'>') == true )
		{
            $installer->add_query("ALTER TABLE `".$installer->table('guildhistory')."` CHANGE `time` `time` INT( 20 ) NULL DEFAULT NULL"); 
            $installer->add_query("ALTER TABLE `".$installer->table('guildhistory')."` CHANGE `logtime` `logtime` INT( 20 ) NULL DEFAULT NULL"); 
            $installer->add_config("'1040','guildhistory_mouse_over', '1', 'radio{on^1|off^0', 'guildhistory_conf'");
		}
		if( version_compare('2.3.0', $oldversion,'>') == true )
		{
            $installer->remove_all_config();
    		$installer->add_config("'1','startpage','guildhistory_conf','display','master'");
    		$installer->add_config("'110','guildhistory_conf',NULL,'blockframe','menu'");
    		$installer->add_config("'1010','guildhistory_access','11:1','access','guildhistory_conf'");
    		$installer->add_config("'1020','guildhistory_textformat', '0', 'radio{extended^1|simple^0', 'guildhistory_conf'");
            $installer->add_config("'1030','guildhistory_mouse_over', '1', 'radio{on^1|off^0', 'guildhistory_conf'");
            $installer->add_config("'1040','guildhistory_ajax', '1', 'radio{on^1|off^0', 'guildhistory_conf'");            
            $installer->add_config("'1050', 'guildhistory_fontsize', '1', 'select{0.5em^0.5|0.8em^0.8|1em^1|1.5em^1.5|2em^2|2.5em,2.5|3em,3', 'guildhistory_conf'");            
            $installer->add_config("'1060', 'guildhistory_defaultsort', 'ASC', 'select{Ascending^ASC|Descending^DESC', 'guildhistory_conf'");            
            $installer->add_config("'1070', 'guildhistory_autopurge', '0', 'select{Never^0|1^1|2^2|3^3|4^4|5^5|6^6|12^12|24^24|36^36|48^48', 'guildhistory_conf'");            
		}	
		return true;
	}
	/**
	 * Un-Install Function
	 *
	 * @return bool
	 */
	function uninstall()
	{
		global $installer;
		$installer->remove_all_config();
		$installer->drop_table($installer->table('guildhistory'));
		$installer->remove_all_menu_button();
		return true;
	}
}